明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 2359|回复: 3

请问如何获取当前图的所有图层?

[复制链接]
发表于 2011-8-29 11:51:51 | 显示全部楼层 |阅读模式
Database db = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument.Database;
          Transaction trans = db.TransactionManager.StartTransaction();
          try
          {
              BlockTable bt = (BlockTable)(trans.GetObject(db.BlockTableId, OpenMode.ForWrite));
              BlockTableRecord btr = (BlockTableRecord)trans.GetObject(bt[BlockTableRecord.ModelSpace], OpenMode.ForWrite);
              //Create the block reference...use the return from CreateEmployeeDefinition directly!
              BlockReference br = new BlockReference(pStart, CreatePolePedDefinition(pCellName));
              br.LayerId = CreateLayer(pLayerName);
              ObjectId newBtrId = btr.AppendEntity(br); //Add the reference to ModelSpace
              trans.AddNewlyCreatedDBObject(br, true); //Let the transaction know about it
              DBObject obj = trans.GetObject(newBtrId, OpenMode.ForWrite);
              XDataDispose.AddRegAppTableRecord("xlentComms");
              ResultBuffer rb = new ResultBuffer(
                  new TypedValue(1001, "xlentComms"),
                  new TypedValue(1000, pMslink + "," + pEntityNo)
                );
             obj.XData = rb;
             rb.Dispose();
             trans.Commit(); // Commit is always required to indicate success.
             Editor ed = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument.Editor;
             //db.SaveAs(ed.Document.Name, null);
             db.SaveAs(ed.Document.Name, true, DwgVersion.Current, db.SecurityParameters);
          }

现在要获取当前图中所有pLayerName
发表于 2011-8-29 13:48:05 | 显示全部楼层
  1. Function GetLayers() As String()
  2.       
  3.         Using Trans As Transaction = DB.TransactionManager.StartTransaction
  4.             Dim LayT As LayerTable = Trans.GetObject(DB.LayerTableId, OpenMode.ForRead)
  5.             Dim ID As ObjectId, LayTR As LayerTableRecord, Lays As New List(Of String)
  6.             For Each ID In LayT
  7.                 LayTR = Trans.GetObject(ID, OpenMode.ForRead)
  8.                 Lays.Add(LayTR.Name)
  9.             Next
  10.             Trans.Commit()
  11.             GetLayers = Lays.ToArray
  12.         End Using
  13.     End Function
发表于 2011-8-29 16:38:04 | 显示全部楼层
             Database db = HostApplicationServices.WorkingDatabase;
             List<LayerTableRecord> list = new List<LayerTableRecord>();
             using (Transaction trans = db.TransactionManager.StartTransaction())
             {
                 LayerTable layertable = (LayerTable)trans.GetObject(db.LayerTableId,
OpenMode.ForWrite);  //得到所有的层表
                 if (layertable != null)
                 {
                     foreach (ObjectId id in layertable)   //遍历层表
                     {
                          LayerTableRecord tr=trans.GetObject(id,OpenMode.ForRead)
                     as LayerTableRecord;   //获得层表记录
                          list.Add(tr);   //将所有的图层放入一个集合中
                     }
                  
                 }
          }     
     希望能帮到你!!!

点评

xgr
这个方法好,图层List对图层处理很方便。  发表于 2011-9-2 19:04
 楼主| 发表于 2011-8-29 16:40:42 | 显示全部楼层
谢谢!
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-11-25 20:38 , Processed in 0.165693 second(s), 25 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表